<html>
<head>
<title>OgreGTKGLSupport.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c8ca15019372142220dfdb263012dc84.html">gtk</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGTKGLSupport.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGTKGLSupport_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef INCL_OGRE_GTKGLSUPPORT_H</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define INCL_OGRE_GTKGLSUPPORT_H</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLSupport_8h.html">OgreGLSupport.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;gtkmm/main.h&gt;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;gtkglmm.h&gt;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">class </span>OGREWidget;
<a name="l00040"></a>00040 
<a name="l00047"></a><a class="code" href="classOgre_1_1GTKGLSupport.html">00047</a> <span class="keyword">class </span><a class="code" href="classOgre_1_1GTKGLSupport.html" title="GL support in a GTK window.">GTKGLSupport</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLSupport.html">GLSupport</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;GTKGLSupport&gt;
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050     <a class="code" href="classOgre_1_1GTKGLSupport.html#aae1f23a6b49fa49f0043fc55c649c879">GTKGLSupport</a>();
<a name="l00051"></a>00051     <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GTKGLSupport.html#a945b00b48e46c35d07f6224e92e3268f" title="Add any special config values to the system.">addConfig</a>();
<a name="l00052"></a>00052     <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GTKGLSupport.html#ab83dcc8d4c807945839909cac8438573">setConfigOptions</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; value);
<a name="l00053"></a>00053     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GTKGLSupport.html#af42f2d1cf0c9d4ad08dd182697a19228" title="Make sure all the extra options are valid.">validateConfig</a>();
<a name="l00054"></a>00054     <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* <a class="code" href="classOgre_1_1GTKGLSupport.html#a97a47c0f69cf87fee09794ec55a46857">createWindow</a>(<span class="keywordtype">bool</span> autoCreateWindow, 
<a name="l00055"></a>00055                                <a class="code" href="classOgre_1_1GLRenderSystem.html" title="Implementation of GL as a rendering system.">GLRenderSystem</a>* renderSystem, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; windowTitle);
<a name="l00056"></a>00056     <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* <a class="code" href="classOgre_1_1GTKGLSupport.html#a006330778de80990dbbf0b27bde4b4be">newWindow</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, 
<a name="l00057"></a>00057                             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> colourDepth, <span class="keywordtype">bool</span> fullScreen, <span class="keywordtype">int</span> left, <span class="keywordtype">int</span> top,
<a name="l00058"></a>00058                             <span class="keywordtype">bool</span> depthBuffer, <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* parentWindowHandle,
<a name="l00059"></a>00059                             <span class="keywordtype">bool</span> vsync);
<a name="l00060"></a>00060     <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GTKGLSupport.html#a210971bd389a3f83cac848086342dd5e" title="Start anything special.">start</a>();
<a name="l00061"></a>00061     <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GTKGLSupport.html#ada1cd7ab977c735c1bbae6ec385c8eb9" title="Stop anything special.">stop</a>();
<a name="l00062"></a>00062     <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GTKGLSupport.html#a2d3fa8fba0933579a905d34201892da2">begin_context</a>(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *_target = 0);
<a name="l00063"></a>00063     <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GTKGLSupport.html#a32a473e88dd9c9b69d0eac0bb914f891">end_context</a>();
<a name="l00064"></a>00064     <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GTKGLSupport.html#ad5810ecfd4497986d8427faa2e60ad60" title="Initialises GL extensions, must be done AFTER the GL context has been established.">initialiseExtensions</a>(<span class="keywordtype">void</span>);
<a name="l00065"></a>00065     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GTKGLSupport.html#a36e26ed10e5f16aded817ce67e7492fd" title="Compare GL version numbers.">checkMinGLVersion</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; v) <span class="keyword">const</span>;
<a name="l00066"></a>00066     <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GTKGLSupport.html#a670b7bdca00d8c60c3ddaf763b3e74b4" title="Check if an extension is available.">checkExtension</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; ext) <span class="keyword">const</span>;
<a name="l00067"></a>00067     <span class="keywordtype">void</span>* <a class="code" href="classOgre_1_1GTKGLSupport.html#a5ad1fcb66875e86d0608eb26b6276de4" title="Get the address of a function.">getProcAddress</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; procname);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069     Glib::RefPtr&lt;const Gdk::GL::Context&gt; <a class="code" href="classOgre_1_1GTKGLSupport.html#a04e34d8032488d07d9a11e5f0380aab6">getMainContext</a>() <span class="keyword">const</span>; 
<a name="l00070"></a>00070 
<a name="l00086"></a>00086     <span class="keyword">static</span> <a class="code" href="classOgre_1_1GTKGLSupport.html" title="GL support in a GTK window.">GTKGLSupport</a>&amp; <a class="code" href="classOgre_1_1GTKGLSupport.html#a50729ef52d459529d422f717d12b8264" title="Override standard Singleton retrieval.">getSingleton</a>(<span class="keywordtype">void</span>);
<a name="l00102"></a>00102     <span class="keyword">static</span> <a class="code" href="classOgre_1_1GTKGLSupport.html" title="GL support in a GTK window.">GTKGLSupport</a>* <a class="code" href="classOgre_1_1GTKGLSupport.html#a29ae1bf3c244d51ac7cae12733b3c69d" title="Override standard Singleton retrieval.">getSingletonPtr</a>(<span class="keywordtype">void</span>);
<a name="l00103"></a>00103 <span class="keyword">private</span>:
<a name="l00104"></a><a class="code" href="classOgre_1_1GTKGLSupport.html#a29b121bf19ce6b1d429f9151dfa5125f">00104</a>     <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1GTKGLSupport.html#a29b121bf19ce6b1d429f9151dfa5125f">_context_ref</a>;
<a name="l00105"></a><a class="code" href="classOgre_1_1GTKGLSupport.html#af24901b37434ed4f65e9260b0ff20288">00105</a>     Gtk::Main <a class="code" href="classOgre_1_1GTKGLSupport.html#af24901b37434ed4f65e9260b0ff20288">_kit</a>;
<a name="l00106"></a>00106     <span class="comment">//OGREWidget* _ogre_widget;</span>
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="classOgre_1_1GTKGLSupport.html#aae513a127f303967243422faa478c05c">00108</a>     Glib::RefPtr&lt;Gdk::GL::Context&gt; <a class="code" href="classOgre_1_1GTKGLSupport.html#aae513a127f303967243422faa478c05c">_main_context</a>;
<a name="l00109"></a><a class="code" href="classOgre_1_1GTKGLSupport.html#ad6b503e273f4fac943bde55b33da2ce3">00109</a>     Glib::RefPtr&lt;Gdk::GL::Window&gt; <a class="code" href="classOgre_1_1GTKGLSupport.html#ad6b503e273f4fac943bde55b33da2ce3">_main_window</a>;
<a name="l00110"></a>00110 }; <span class="comment">// class GTKGLSupport</span>
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 }; <span class="comment">// namespace Ogre</span>
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 <span class="preprocessor">#endif // INCL_OGRE_GTKGLSUPPORT_H</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
